vector-0.13.1.0: Efficient Arrays

Copyright | (c) Roman Leshchinskiy 2008-2011 Alexey Kuleshevich 2020-2022 Aleksey Khudyakov 2020-2022 Andrew Lelechenko 2020-2022
License | BSD-style
Maintainer | Haskell Libraries Team <libraries@haskell.org>
Stability | experimental
Portability | non-portable
Safe Haskell | Safe-Inferred
Language | Haskell2010

Data.Vector.Generic.Mutable.Base

Description

Class of mutable vectors.

Synopsis

- class MVector (v :: Type -> Type -> Type) a where
  - basicLength :: v s a -> Int
  - basicUnsafeSlice :: Int -> Int -> v s a -> v s a
  - basicOverlaps :: v s a -> v s a -> Bool
  - basicUnsafeNew :: Int -> ST s (v s a)
  - basicInitialize :: v s a -> ST s ()
  - basicUnsafeReplicate :: Int -> a -> ST s (v s a)
  - basicUnsafeRead :: v s a -> Int -> ST s a
  - basicUnsafeWrite :: v s a -> Int -> a -> ST s ()
  - basicClear :: v s a -> ST s ()
  - basicSet :: v s a -> a -> ST s ()
  - basicUnsafeCopy :: v s a -> v s a -> ST s ()
  - basicUnsafeMove :: v s a -> v s a -> ST s ()
  - basicUnsafeGrow :: v s a -> Int -> ST s (v s a)

# Documentation

class MVector (v :: Type -> Type -> Type) a where #

Class of mutable vectors parameterised with a primitive state token.

Minimal complete definition

basicLength, basicUnsafeSlice, basicOverlaps, basicUnsafeNew, basicInitialize, basicUnsafeRead, basicUnsafeWrite

Methods

basicLength :: v s a -> Int #

Length of the mutable vector. This method should not be called directly, use `length` instead.

basicUnsafeSlice #

Arguments

:: Int | starting index
-> Int | length of the slice
-> v s a |
-> v s a |

Yield a part of the mutable vector without copying it. This method should not be called directly, use `unsafeSlice` instead.

basicOverlaps :: v s a -> v s a -> Bool #

Check whether two vectors overlap. This method should not be called directly, use `overlaps` instead.

basicUnsafeNew :: Int -> ST s (v s a) #

Create a mutable vector of the given length. This method should not be called directly, use `unsafeNew` instead.

basicInitialize :: v s a -> ST s () #

Initialize a vector to a standard value. This is intended to be called as part of the safe new operation (and similar operations), to properly blank the newly allocated memory if necessary.

Vectors that are necessarily initialized as part of creation may implement this as a no-op.

Since: 0.11.0.0

basicUnsafeReplicate :: Int -> a -> ST s (v s a) #

Create a mutable vector of the given length and fill it with an initial value. This method should not be called directly, use `replicate` instead.

basicUnsafeRead :: v s a -> Int -> ST s a #

Yield the element at the given position. This method should not be called directly, use `unsafeRead` instead.

basicUnsafeWrite :: v s a -> Int -> a -> ST s () #

Replace the element at the given position. This method should not be called directly, use `unsafeWrite` instead.

basicClear :: v s a -> ST s () #

Reset all elements of the vector to some undefined value, clearing all references to external objects. This is usually a noop for unboxed vectors. This method should not be called directly, use `clear` instead.

basicSet :: v s a -> a -> ST s () #

Set all elements of the vector to the given value. This method should not be called directly, use `set` instead.

basicUnsafeCopy #

Arguments

:: v s a | target
-> v s a | source
-> ST s () |

Copy a vector. The two vectors may not overlap. This method should not be called directly, use `unsafeCopy` instead.

basicUnsafeMove #

Arguments

:: v s a | target
-> v s a | source
-> ST s () |

Move the contents of a vector. The two vectors may overlap. This method should not be called directly, use `unsafeMove` instead.

basicUnsafeGrow :: v s a -> Int -> ST s (v s a) #

Grow a vector by the given number of elements. Allocates a new vector and copies all of the elements over starting at 0 index. This method should not be called directly, use `grow`/`unsafeGrow` instead.

#### Instances

Instances details

MVector MVector a # |

Instance details

Defined in Data.Vector.Mutable

Methods

basicLength :: MVector s a -> Int #

basicUnsafeSlice :: Int -> Int -> MVector s a -> MVector s a #

basicOverlaps :: MVector s a -> MVector s a -> Bool #

basicUnsafeNew :: Int -> ST s (MVector s a) #

basicInitialize :: MVector s a -> ST s () #

basicUnsafeReplicate :: Int -> a -> ST s (MVector s a) #

basicUnsafeRead :: MVector s a -> Int -> ST s a #

basicUnsafeWrite :: MVector s a -> Int -> a -> ST s () #

basicClear :: MVector s a -> ST s () #

basicSet :: MVector s a -> a -> ST s () #

basicUnsafeCopy :: MVector s a -> MVector s a -> ST s () #

basicUnsafeMove :: MVector s a -> MVector s a -> ST s () #

basicUnsafeGrow :: MVector s a -> Int -> ST s (MVector s a) #

Prim a => MVector MVector a # |

Instance details

Defined in Data.Vector.Primitive.Mutable

Methods

basicLength :: MVector s a -> Int #

basicUnsafeSlice :: Int -> Int -> MVector s a -> MVector s a #

basicOverlaps :: MVector s a -> MVector s a -> Bool #

basicUnsafeNew :: Int -> ST s (MVector s a) #

basicInitialize :: MVector s a -> ST s () #

basicUnsafeReplicate :: Int -> a -> ST s (MVector s a) #

basicUnsafeRead :: MVector s a -> Int -> ST s a #

basicUnsafeWrite :: MVector s a -> Int -> a -> ST s () #

basicClear :: MVector s a -> ST s () #

basicSet :: MVector s a -> a -> ST s () #

basicUnsafeCopy :: MVector s a -> MVector s a -> ST s () #

basicUnsafeMove :: MVector s a -> MVector s a -> ST s () #

basicUnsafeGrow :: MVector s a -> Int -> ST s (MVector s a) #

Storable a => MVector MVector a # |

Instance details

Defined in Data.Vector.Storable.Mutable

Methods

basicLength :: MVector s a -> Int #

basicUnsafeSlice :: Int -> Int -> MVector s a -> MVector s a #

basicOverlaps :: MVector s a -> MVector s a -> Bool #

basicUnsafeNew :: Int -> ST s (MVector s a) #

basicInitialize :: MVector s a -> ST s () #

basicUnsafeReplicate :: Int -> a -> ST s (MVector s a) #

basicUnsafeRead :: MVector s a -> Int -> ST s a #

basicUnsafeWrite :: MVector s a -> Int -> a -> ST s () #

basicClear :: MVector s a -> ST s () #

basicSet :: MVector s a -> a -> ST s () #

basicUnsafeCopy :: MVector s a -> MVector s a -> ST s () #

basicUnsafeMove :: MVector s a -> MVector s a -> ST s () #

basicUnsafeGrow :: MVector s a -> Int -> ST s (MVector s a) #

MVector MVector All # |

Instance details

Defined in Data.Vector.Unboxed.Base

Methods

basicLength :: MVector s All -> Int #

basicUnsafeSlice :: Int -> Int -> MVector s All -> MVector s All #

basicOverlaps :: MVector s All -> MVector s All -> Bool #

basicUnsafeNew :: Int -> ST s (MVector s All) #

basicInitialize :: MVector s All -> ST s () #

basicUnsafeReplicate :: Int -> All -> ST s (MVector s All) #

basicUnsafeRead :: MVector s All -> Int -> ST s All #

basicUnsafeWrite :: MVector s All -> Int -> All -> ST s () #

basicClear :: MVector s All -> ST s () #

basicSet :: MVector s All -> All -> ST s () #

basicUnsafeCopy :: MVector s All -> MVector s All -> ST s () #

basicUnsafeMove :: MVector s All -> MVector s All -> ST s () #

basicUnsafeGrow :: MVector s All -> Int -> ST s (MVector s All) #

MVector MVector Any # |

Instance details

Defined in Data.Vector.Unboxed.Base

Methods

basicLength :: MVector s Any -> Int #

basicUnsafeSlice :: Int -> Int -> MVector s Any -> MVector s Any #

basicOverlaps :: MVector s Any -> MVector s Any -> Bool #

basicUnsafeNew :: Int -> ST s (MVector s Any) #

basicInitialize :: MVector s Any -> ST s () #

basicUnsafeReplicate :: Int -> Any -> ST s (MVector s Any) #

basicUnsafeRead :: MVector s Any -> Int -> ST s Any #

basicUnsafeWrite :: MVector s Any -> Int -> Any -> ST s () #

basicClear :: MVector s Any -> ST s () #

basicSet :: MVector s Any -> Any -> ST s () #

basicUnsafeCopy :: MVector s Any -> MVector s Any -> ST s () #

basicUnsafeMove :: MVector s Any -> MVector s Any -> ST s () #

basicUnsafeGrow :: MVector s Any -> Int -> ST s (MVector s Any) #

MVector MVector Int16 # |

Instance details

Defined in Data.Vector.Unboxed.Base

Methods

basicLength :: MVector s Int16 -> Int #

basicUnsafeSlice :: Int -> Int -> MVector s Int16 -> MVector s Int16 #

basicOverlaps :: MVector s Int16 -> MVector s Int16 -> Bool #

basicUnsafeNew :: Int -> ST s (MVector s Int16) #

basicInitialize :: MVector s Int16 -> ST s () #

basicUnsafeReplicate :: Int -> Int16 -> ST s (MVector s Int16) #

basicUnsafeRead :: MVector s Int16 -> Int -> ST s Int16 #

basicUnsafeWrite :: MVector s Int16 -> Int -> Int16 -> ST s () #

basicClear :: MVector s Int16 -> ST s () #

basicSet :: MVector s Int16 -> Int16 -> ST s () #

basicUnsafeCopy :: MVector s Int16 -> MVector s Int16 -> ST s () #

basicUnsafeMove :: MVector s Int16 -> MVector s Int16 -> ST s () #

basicUnsafeGrow :: MVector s Int16 -> Int -> ST s (MVector s Int16) #

MVector MVector Int32 # |

Instance details

Defined in Data.Vector.Unboxed.Base

Methods

basicLength :: MVector s Int32 -> Int #

basicUnsafeSlice :: Int -> Int -> MVector s Int32 -> MVector s Int32 #

basicOverlaps :: MVector s Int32 -> MVector s Int32 -> Bool #

basicUnsafeNew :: Int -> ST s (MVector s Int32) #

basicInitialize :: MVector s Int32 -> ST s () #

basicUnsafeReplicate :: Int -> Int32 -> ST s (MVector s Int32) #

basicUnsafeRead :: MVector s Int32 -> Int -> ST s Int32 #

basicUnsafeWrite :: MVector s Int32 -> Int -> Int32 -> ST s () #

basicClear :: MVector s Int32 -> ST s () #

basicSet :: MVector s Int32 -> Int32 -> ST s () #

basicUnsafeCopy :: MVector s Int32 -> MVector s Int32 -> ST s () #

basicUnsafeMove :: MVector s Int32 -> MVector s Int32 -> ST s () #

basicUnsafeGrow :: MVector s Int32 -> Int -> ST s (MVector s Int32) #

MVector MVector Int64 # |

Instance details

Defined in Data.Vector.Unboxed.Base

Methods

basicLength :: MVector s Int64 -> Int #

basicUnsafeSlice :: Int -> Int -> MVector s Int64 -> MVector s Int64 #

basicOverlaps :: MVector s Int64 -> MVector s Int64 -> Bool #

basicUnsafeNew :: Int -> ST s (MVector s Int64) #

basicInitialize :: MVector s Int64 -> ST s () #

basicUnsafeReplicate :: Int -> Int64 -> ST s (MVector s Int64) #

basicUnsafeRead :: MVector s Int64 -> Int -> ST s Int64 #

basicUnsafeWrite :: MVector s Int64 -> Int -> Int64 -> ST s () #

basicClear :: MVector s Int64 -> ST s () #

basicSet :: MVector s Int64 -> Int64 -> ST s () #

basicUnsafeCopy :: MVector s Int64 -> MVector s Int64 -> ST s () #

basicUnsafeMove :: MVector s Int64 -> MVector s Int64 -> ST s () #

basicUnsafeGrow :: MVector s Int64 -> Int -> ST s (MVector s Int64) #

MVector MVector Int8 # |

Instance details

Defined in Data.Vector.Unboxed.Base

Methods

basicLength :: MVector s Int8 -> Int #

basicUnsafeSlice :: Int -> Int -> MVector s Int8 -> MVector s Int8 #

basicOverlaps :: MVector s Int8 -> MVector s Int8 -> Bool #

basicUnsafeNew :: Int -> ST s (MVector s Int8) #

basicInitialize :: MVector s Int8 -> ST s () #

basicUnsafeReplicate :: Int -> Int8 -> ST s (MVector s Int8) #

basicUnsafeRead :: MVector s Int8 -> Int -> ST s Int8 #

basicUnsafeWrite :: MVector s Int8 -> Int -> Int8 -> ST s () #

basicClear :: MVector s Int8 -> ST s () #

basicSet :: MVector s Int8 -> Int8 -> ST s () #

basicUnsafeCopy :: MVector s Int8 -> MVector s Int8 -> ST s () #

basicUnsafeMove :: MVector s Int8 -> MVector s Int8 -> ST s () #

basicUnsafeGrow :: MVector s Int8 -> Int -> ST s (MVector s Int8) #

MVector MVector Word16 # |

Instance details

Defined in Data.Vector.Unboxed.Base

Methods

basicLength :: MVector s Word16 -> Int #

basicUnsafeSlice :: Int -> Int -> MVector s Word16 -> MVector s Word16 #

basicOverlaps :: MVector s Word16 -> MVector s Word16 -> Bool #

basicUnsafeNew :: Int -> ST s (MVector s Word16) #

basicInitialize :: MVector s Word16 -> ST s () #

basicUnsafeReplicate :: Int -> Word16 -> ST s (MVector s Word16) #

basicUnsafeRead :: MVector s Word16 -> Int -> ST s Word16 #

basicUnsafeWrite :: MVector s Word16 -> Int -> Word16 -> ST s () #

basicClear :: MVector s Word16 -> ST s () #

basicSet :: MVector s Word16 -> Word16 -> ST s () #

basicUnsafeCopy :: MVector s Word16 -> MVector s Word16 -> ST s () #

basicUnsafeMove :: MVector s Word16 -> MVector s Word16 -> ST s () #

basicUnsafeGrow :: MVector s Word16 -> Int -> ST s (MVector s Word16) #

MVector MVector Word32 # |

Instance details

Defined in Data.Vector.Unboxed.Base

Methods

basicLength :: MVector s Word32 -> Int #

basicUnsafeSlice :: Int -> Int -> MVector s Word32 -> MVector s Word32 #

basicOverlaps :: MVector s Word32 -> MVector s Word32 -> Bool #

basicUnsafeNew :: Int -> ST s (MVector s Word32) #

basicInitialize :: MVector s Word32 -> ST s () #

basicUnsafeReplicate :: Int -> Word32 -> ST s (MVector s Word32) #

basicUnsafeRead :: MVector s Word32 -> Int -> ST s Word32 #

basicUnsafeWrite :: MVector s Word32 -> Int -> Word32 -> ST s () #

basicClear :: MVector s Word32 -> ST s () #

basicSet :: MVector s Word32 -> Word32 -> ST s () #

basicUnsafeCopy :: MVector s Word32 -> MVector s Word32 -> ST s () #

basicUnsafeMove :: MVector s Word32 -> MVector s Word32 -> ST s () #

basicUnsafeGrow :: MVector s Word32 -> Int -> ST s (MVector s Word32) #

MVector MVector Word64 # |

Instance details

Defined in Data.Vector.Unboxed.Base

Methods

basicLength :: MVector s Word64 -> Int #

basicUnsafeSlice :: Int -> Int -> MVector s Word64 -> MVector s Word64 #

basicOverlaps :: MVector s Word64 -> MVector s Word64 -> Bool #

basicUnsafeNew :: Int -> ST s (MVector s Word64) #

basicInitialize :: MVector s Word64 -> ST s () #

basicUnsafeReplicate :: Int -> Word64 -> ST s (MVector s Word64) #

basicUnsafeRead :: MVector s Word64 -> Int -> ST s Word64 #

basicUnsafeWrite :: MVector s Word64 -> Int -> Word64 -> ST s () #

basicClear :: MVector s Word64 -> ST s () #

basicSet :: MVector s Word64 -> Word64 -> ST s () #

basicUnsafeCopy :: MVector s Word64 -> MVector s Word64 -> ST s () #

basicUnsafeMove :: MVector s Word64 -> MVector s Word64 -> ST s () #

basicUnsafeGrow :: MVector s Word64 -> Int -> ST s (MVector s Word64) #

MVector MVector Word8 # |

Instance details

Defined in Data.Vector.Unboxed.Base

Methods

basicLength :: MVector s Word8 -> Int #

basicUnsafeSlice :: Int -> Int -> MVector s Word8 -> MVector s Word8 #

basicOverlaps :: MVector s Word8 -> MVector s Word8 -> Bool #

basicUnsafeNew :: Int -> ST s (MVector s Word8) #

basicInitialize :: MVector s Word8 -> ST s () #

basicUnsafeReplicate :: Int -> Word8 -> ST s (MVector s Word8) #

basicUnsafeRead :: MVector s Word8 -> Int -> ST s Word8 #

basicUnsafeWrite :: MVector s Word8 -> Int -> Word8 -> ST s () #

basicClear :: MVector s Word8 -> ST s () #

basicSet :: MVector s Word8 -> Word8 -> ST s () #

basicUnsafeCopy :: MVector s Word8 -> MVector s Word8 -> ST s () #

basicUnsafeMove :: MVector s Word8 -> MVector s Word8 -> ST s () #

basicUnsafeGrow :: MVector s Word8 -> Int -> ST s (MVector s Word8) #

MVector MVector () # |

Instance details

Defined in Data.Vector.Unboxed.Base

Methods

basicLength :: MVector s () -> Int #

basicUnsafeSlice :: Int -> Int -> MVector s () -> MVector s () #

basicOverlaps :: MVector s () -> MVector s () -> Bool #

basicUnsafeNew :: Int -> ST s (MVector s ()) #

basicInitialize :: MVector s () -> ST s () #

basicUnsafeReplicate :: Int -> () -> ST s (MVector s ()) #

basicUnsafeRead :: MVector s () -> Int -> ST s () #

basicUnsafeWrite :: MVector s () -> Int -> () -> ST s () #

basicClear :: MVector s () -> ST s () #

basicSet :: MVector s () -> () -> ST s () #

basicUnsafeCopy :: MVector s () -> MVector s () -> ST s () #

basicUnsafeMove :: MVector s () -> MVector s () -> ST s () #

basicUnsafeGrow :: MVector s () -> Int -> ST s (MVector s ()) #

MVector MVector Bool # |

Instance details

Defined in Data.Vector.Unboxed.Base

Methods

basicLength :: MVector s Bool -> Int #

basicUnsafeSlice :: Int -> Int -> MVector s Bool -> MVector s Bool #

basicOverlaps :: MVector s Bool -> MVector s Bool -> Bool #

basicUnsafeNew :: Int -> ST s (MVector s Bool) #

basicInitialize :: MVector s Bool -> ST s () #

basicUnsafeReplicate :: Int -> Bool -> ST s (MVector s Bool) #

basicUnsafeRead :: MVector s Bool -> Int -> ST s Bool #

basicUnsafeWrite :: MVector s Bool -> Int -> Bool -> ST s () #

basicClear :: MVector s Bool -> ST s () #

basicSet :: MVector s Bool -> Bool -> ST s () #

basicUnsafeCopy :: MVector s Bool -> MVector s Bool -> ST s () #

basicUnsafeMove :: MVector s Bool -> MVector s Bool -> ST s () #

basicUnsafeGrow :: MVector s Bool -> Int -> ST s (MVector s Bool) #

MVector MVector Char # |

Instance details

Defined in Data.Vector.Unboxed.Base

Methods

basicLength :: MVector s Char -> Int #

basicUnsafeSlice :: Int -> Int -> MVector s Char -> MVector s Char #

basicOverlaps :: MVector s Char -> MVector s Char -> Bool #

basicUnsafeNew :: Int -> ST s (MVector s Char) #

basicInitialize :: MVector s Char -> ST s () #

basicUnsafeReplicate :: Int -> Char -> ST s (MVector s Char) #

basicUnsafeRead :: MVector s Char -> Int -> ST s Char #

basicUnsafeWrite :: MVector s Char -> Int -> Char -> ST s () #

basicClear :: MVector s Char -> ST s () #

basicSet :: MVector s Char -> Char -> ST s () #

basicUnsafeCopy :: MVector s Char -> MVector s Char -> ST s () #

basicUnsafeMove :: MVector s Char -> MVector s Char -> ST s () #

basicUnsafeGrow :: MVector s Char -> Int -> ST s (MVector s Char) #

MVector MVector Double # |

Instance details

Defined in Data.Vector.Unboxed.Base

Methods

basicLength :: MVector s Double -> Int #

basicUnsafeSlice :: Int -> Int -> MVector s Double -> MVector s Double #

basicOverlaps :: MVector s Double -> MVector s Double -> Bool #

basicUnsafeNew :: Int -> ST s (MVector s Double) #

basicInitialize :: MVector s Double -> ST s () #

basicUnsafeReplicate :: Int -> Double -> ST s (MVector s Double) #

basicUnsafeRead :: MVector s Double -> Int -> ST s Double #

basicUnsafeWrite :: MVector s Double -> Int -> Double -> ST s () #

basicClear :: MVector s Double -> ST s () #

basicSet :: MVector s Double -> Double -> ST s () #

basicUnsafeCopy :: MVector s Double -> MVector s Double -> ST s () #

basicUnsafeMove :: MVector s Double -> MVector s Double -> ST s () #

basicUnsafeGrow :: MVector s Double -> Int -> ST s (MVector s Double) #

MVector MVector Float # |

Instance details

Defined in Data.Vector.Unboxed.Base

Methods

basicLength :: MVector s Float -> Int #

basicUnsafeSlice :: Int -> Int -> MVector s Float -> MVector s Float #

basicOverlaps :: MVector s Float -> MVector s Float -> Bool #

basicUnsafeNew :: Int -> ST s (MVector s Float) #

basicInitialize :: MVector s Float -> ST s () #

basicUnsafeReplicate :: Int -> Float -> ST s (MVector s Float) #

basicUnsafeRead :: MVector s Float -> Int -> ST s Float #

basicUnsafeWrite :: MVector s Float -> Int -> Float -> ST s () #

basicClear :: MVector s Float -> ST s () #

basicSet :: MVector s Float -> Float -> ST s () #

basicUnsafeCopy :: MVector s Float -> MVector s Float -> ST s () #

basicUnsafeMove :: MVector s Float -> MVector s Float -> ST s () #

basicUnsafeGrow :: MVector s Float -> Int -> ST s (MVector s Float) #

MVector MVector Int # |

Instance details

Defined in Data.Vector.Unboxed.Base

Methods

basicLength :: MVector s Int -> Int #

basicUnsafeSlice :: Int -> Int -> MVector s Int -> MVector s Int #

basicOverlaps :: MVector s Int -> MVector s Int -> Bool #

basicUnsafeNew :: Int -> ST s (MVector s Int) #

basicInitialize :: MVector s Int -> ST s () #

basicUnsafeReplicate :: Int -> Int -> ST s (MVector s Int) #

basicUnsafeRead :: MVector s Int -> Int -> ST s Int #

basicUnsafeWrite :: MVector s Int -> Int -> Int -> ST s () #

basicClear :: MVector s Int -> ST s () #

basicSet :: MVector s Int -> Int -> ST s () #

basicUnsafeCopy :: MVector s Int -> MVector s Int -> ST s () #

basicUnsafeMove :: MVector s Int -> MVector s Int -> ST s () #

basicUnsafeGrow :: MVector s Int -> Int -> ST s (MVector s Int) #

MVector MVector Word # |

Instance details

Defined in Data.Vector.Unboxed.Base

Methods

basicLength :: MVector s Word -> Int #

basicUnsafeSlice :: Int -> Int -> MVector s Word -> MVector s Word #

basicOverlaps :: MVector s Word -> MVector s Word -> Bool #

basicUnsafeNew :: Int -> ST s (MVector s Word) #

basicInitialize :: MVector s Word -> ST s () #

basicUnsafeReplicate :: Int -> Word -> ST s (MVector s Word) #

basicUnsafeRead :: MVector s Word -> Int -> ST s Word #

basicUnsafeWrite :: MVector s Word -> Int -> Word -> ST s () #

basicClear :: MVector s Word -> ST s () #

basicSet :: MVector s Word -> Word -> ST s () #

basicUnsafeCopy :: MVector s Word -> MVector s Word -> ST s () #

basicUnsafeMove :: MVector s Word -> MVector s Word -> ST s () #

basicUnsafeGrow :: MVector s Word -> Int -> ST s (MVector s Word) #

Unbox a => MVector MVector (Complex a) # |

Instance details

Defined in Data.Vector.Unboxed.Base

Methods

basicLength :: MVector s (Complex a) -> Int #

basicUnsafeSlice :: Int -> Int -> MVector s (Complex a) -> MVector s (Complex a) #

basicOverlaps :: MVector s (Complex a) -> MVector s (Complex a) -> Bool #

basicUnsafeNew :: Int -> ST s (MVector s (Complex a)) #

basicInitialize :: MVector s (Complex a) -> ST s () #

basicUnsafeReplicate :: Int -> Complex a -> ST s (MVector s (Complex a)) #

basicUnsafeRead :: MVector s (Complex a) -> Int -> ST s (Complex a) #

basicUnsafeWrite :: MVector s (Complex a) -> Int -> Complex a -> ST s () #

basicClear :: MVector s (Complex a) -> ST s () #

basicSet :: MVector s (Complex a) -> Complex a -> ST s () #

basicUnsafeCopy :: MVector s (Complex a) -> MVector s (Complex a) -> ST s () #

basicUnsafeMove :: MVector s (Complex a) -> MVector s (Complex a) -> ST s () #

basicUnsafeGrow :: MVector s (Complex a) -> Int -> ST s (MVector s (Complex a)) #

Unbox a => MVector MVector (Identity a) # |

Instance details

Defined in Data.Vector.Unboxed.Base

Methods

basicLength :: MVector s (Identity a) -> Int #

basicUnsafeSlice :: Int -> Int -> MVector s (Identity a) -> MVector s (Identity a) #

basicOverlaps :: MVector s (Identity a) -> MVector s (Identity a) -> Bool #

basicUnsafeNew :: Int -> ST s (MVector s (Identity a)) #

basicInitialize :: MVector s (Identity a) -> ST s () #

basicUnsafeReplicate :: Int -> Identity a -> ST s (MVector s (Identity a)) #

basicUnsafeRead :: MVector s (Identity a) -> Int -> ST s (Identity a) #

basicUnsafeWrite :: MVector s (Identity a) -> Int -> Identity a -> ST s () #

basicClear :: MVector s (Identity a) -> ST s () #

basicSet :: MVector s (Identity a) -> Identity a -> ST s () #

basicUnsafeCopy :: MVector s (Identity a) -> MVector s (Identity a) -> ST s () #

basicUnsafeMove :: MVector s (Identity a) -> MVector s (Identity a) -> ST s () #

basicUnsafeGrow :: MVector s (Identity a) -> Int -> ST s (MVector s (Identity a)) #

Unbox a => MVector MVector (Down a) # |

Instance details

Defined in Data.Vector.Unboxed.Base

Methods

basicLength :: MVector s (Down a) -> Int #

basicUnsafeSlice :: Int -> Int -> MVector s (Down a) -> MVector s (Down a) #

basicOverlaps :: MVector s (Down a) -> MVector s (Down a) -> Bool #

basicUnsafeNew :: Int -> ST s (MVector s (Down a)) #

basicInitialize :: MVector s (Down a) -> ST s () #

basicUnsafeReplicate :: Int -> Down a -> ST s (MVector s (Down a)) #

basicUnsafeRead :: MVector s (Down a) -> Int -> ST s (Down a) #

basicUnsafeWrite :: MVector s (Down a) -> Int -> Down a -> ST s () #

basicClear :: MVector s (Down a) -> ST s () #

basicSet :: MVector s (Down a) -> Down a -> ST s () #

basicUnsafeCopy :: MVector s (Down a) -> MVector s (Down a) -> ST s () #

basicUnsafeMove :: MVector s (Down a) -> MVector s (Down a) -> ST s () #

basicUnsafeGrow :: MVector s (Down a) -> Int -> ST s (MVector s (Down a)) #

Unbox a => MVector MVector (First a) # |

Instance details

Defined in Data.Vector.Unboxed.Base

Methods

basicLength :: MVector s (First a) -> Int #

basicUnsafeSlice :: Int -> Int -> MVector s (First a) -> MVector s (First a) #

basicOverlaps :: MVector s (First a) -> MVector s (First a) -> Bool #

basicUnsafeNew :: Int -> ST s (MVector s (First a)) #

basicInitialize :: MVector s (First a) -> ST s () #

basicUnsafeReplicate :: Int -> First a -> ST s (MVector s (First a)) #

basicUnsafeRead :: MVector s (First a) -> Int -> ST s (First a) #

basicUnsafeWrite :: MVector s (First a) -> Int -> First a -> ST s () #

basicClear :: MVector s (First a) -> ST s () #

basicSet :: MVector s (First a) -> First a -> ST s () #

basicUnsafeCopy :: MVector s (First a) -> MVector s (First a) -> ST s () #

basicUnsafeMove :: MVector s (First a) -> MVector s (First a) -> ST s () #

basicUnsafeGrow :: MVector s (First a) -> Int -> ST s (MVector s (First a)) #

Unbox a => MVector MVector (Last a) # |

Instance details

Defined in Data.Vector.Unboxed.Base

Methods

basicLength :: MVector s (Last a) -> Int #

basicUnsafeSlice :: Int -> Int -> MVector s (Last a) -> MVector s (Last a) #

basicOverlaps :: MVector s (Last a) -> MVector s (Last a) -> Bool #

basicUnsafeNew :: Int -> ST s (MVector s (Last a)) #

basicInitialize :: MVector s (Last a) -> ST s () #

basicUnsafeReplicate :: Int -> Last a -> ST s (MVector s (Last a)) #

basicUnsafeRead :: MVector s (Last a) -> Int -> ST s (Last a) #

basicUnsafeWrite :: MVector s (Last a) -> Int -> Last a -> ST s () #

basicClear :: MVector s (Last a) -> ST s () #

basicSet :: MVector s (Last a) -> Last a -> ST s () #

basicUnsafeCopy :: MVector s (Last a) -> MVector s (Last a) -> ST s () #

basicUnsafeMove :: MVector s (Last a) -> MVector s (Last a) -> ST s () #

basicUnsafeGrow :: MVector s (Last a) -> Int -> ST s (MVector s (Last a)) #

Unbox a => MVector MVector (Max a) # |

Instance details

Defined in Data.Vector.Unboxed.Base

Methods

basicLength :: MVector s (Max a) -> Int #

basicUnsafeSlice :: Int -> Int -> MVector s (Max a) -> MVector s (Max a) #

basicOverlaps :: MVector s (Max a) -> MVector s (Max a) -> Bool #

basicUnsafeNew :: Int -> ST s (MVector s (Max a)) #

basicInitialize :: MVector s (Max a) -> ST s () #

basicUnsafeReplicate :: Int -> Max a -> ST s (MVector s (Max a)) #

basicUnsafeRead :: MVector s (Max a) -> Int -> ST s (Max a) #

basicUnsafeWrite :: MVector s (Max a) -> Int -> Max a -> ST s () #

basicClear :: MVector s (Max a) -> ST s () #

basicSet :: MVector s (Max a) -> Max a -> ST s () #

basicUnsafeCopy :: MVector s (Max a) -> MVector s (Max a) -> ST s () #

basicUnsafeMove :: MVector s (Max a) -> MVector s (Max a) -> ST s () #

basicUnsafeGrow :: MVector s (Max a) -> Int -> ST s (MVector s (Max a)) #

Unbox a => MVector MVector (Min a) # |

Instance details

Defined in Data.Vector.Unboxed.Base

Methods

basicLength :: MVector s (Min a) -> Int #

basicUnsafeSlice :: Int -> Int -> MVector s (Min a) -> MVector s (Min a) #

basicOverlaps :: MVector s (Min a) -> MVector s (Min a) -> Bool #

basicUnsafeNew :: Int -> ST s (MVector s (Min a)) #

basicInitialize :: MVector s (Min a) -> ST s () #

basicUnsafeReplicate :: Int -> Min a -> ST s (MVector s (Min a)) #

basicUnsafeRead :: MVector s (Min a) -> Int -> ST s (Min a) #

basicUnsafeWrite :: MVector s (Min a) -> Int -> Min a -> ST s () #

basicClear :: MVector s (Min a) -> ST s () #

basicSet :: MVector s (Min a) -> Min a -> ST s () #

basicUnsafeCopy :: MVector s (Min a) -> MVector s (Min a) -> ST s () #

basicUnsafeMove :: MVector s (Min a) -> MVector s (Min a) -> ST s () #

basicUnsafeGrow :: MVector s (Min a) -> Int -> ST s (MVector s (Min a)) #

Unbox a => MVector MVector (WrappedMonoid a) # |

Instance details

Defined in Data.Vector.Unboxed.Base

Methods

basicLength :: MVector s (WrappedMonoid a) -> Int #

basicUnsafeSlice :: Int -> Int -> MVector s (WrappedMonoid a) -> MVector s (WrappedMonoid a) #

basicOverlaps :: MVector s (WrappedMonoid a) -> MVector s (WrappedMonoid a) -> Bool #

basicUnsafeNew :: Int -> ST s (MVector s (WrappedMonoid a)) #

basicInitialize :: MVector s (WrappedMonoid a) -> ST s () #

basicUnsafeReplicate :: Int -> WrappedMonoid a -> ST s (MVector s (WrappedMonoid a)) #

basicUnsafeRead :: MVector s (WrappedMonoid a) -> Int -> ST s (WrappedMonoid a) #

basicUnsafeWrite :: MVector s (WrappedMonoid a) -> Int -> WrappedMonoid a -> ST s () #

basicClear :: MVector s (WrappedMonoid a) -> ST s () #

basicSet :: MVector s (WrappedMonoid a) -> WrappedMonoid a -> ST s () #

basicUnsafeCopy :: MVector s (WrappedMonoid a) -> MVector s (WrappedMonoid a) -> ST s () #

basicUnsafeMove :: MVector s (WrappedMonoid a) -> MVector s (WrappedMonoid a) -> ST s () #

basicUnsafeGrow :: MVector s (WrappedMonoid a) -> Int -> ST s (MVector s (WrappedMonoid a)) #

Unbox a => MVector MVector (Dual a) # |

Instance details

Defined in Data.Vector.Unboxed.Base

Methods

basicLength :: MVector s (Dual a) -> Int #

basicUnsafeSlice :: Int -> Int -> MVector s (Dual a) -> MVector s (Dual a) #

basicOverlaps :: MVector s (Dual a) -> MVector s (Dual a) -> Bool #

basicUnsafeNew :: Int -> ST s (MVector s (Dual a)) #

basicInitialize :: MVector s (Dual a) -> ST s () #

basicUnsafeReplicate :: Int -> Dual a -> ST s (MVector s (Dual a)) #

basicUnsafeRead :: MVector s (Dual a) -> Int -> ST s (Dual a) #

basicUnsafeWrite :: MVector s (Dual a) -> Int -> Dual a -> ST s () #

basicClear :: MVector s (Dual a) -> ST s () #

basicSet :: MVector s (Dual a) -> Dual a -> ST s () #

basicUnsafeCopy :: MVector s (Dual a) -> MVector s (Dual a) -> ST s () #

basicUnsafeMove :: MVector s (Dual a) -> MVector s (Dual a) -> ST s () #

basicUnsafeGrow :: MVector s (Dual a) -> Int -> ST s (MVector s (Dual a)) #

Unbox a => MVector MVector (Product a) # |

Instance details

Defined in Data.Vector.Unboxed.Base

Methods

basicLength :: MVector s (Product a) -> Int #

basicUnsafeSlice :: Int -> Int -> MVector s (Product a) -> MVector s (Product a) #

basicOverlaps :: MVector s (Product a) -> MVector s (Product a) -> Bool #

basicUnsafeNew :: Int -> ST s (MVector s (Product a)) #

basicInitialize :: MVector s (Product a) -> ST s () #

basicUnsafeReplicate :: Int -> Product a -> ST s (MVector s (Product a)) #

basicUnsafeRead :: MVector s (Product a) -> Int -> ST s (Product a) #

basicUnsafeWrite :: MVector s (Product a) -> Int -> Product a -> ST s () #

basicClear :: MVector s (Product a) -> ST s () #

basicSet :: MVector s (Product a) -> Product a -> ST s () #

basicUnsafeCopy :: MVector s (Product a) -> MVector s (Product a) -> ST s () #

basicUnsafeMove :: MVector s (Product a) -> MVector s (Product a) -> ST s () #

basicUnsafeGrow :: MVector s (Product a) -> Int -> ST s (MVector s (Product a)) #

Unbox a => MVector MVector (Sum a) # |

Instance details

Defined in Data.Vector.Unboxed.Base

Methods

basicLength :: MVector s (Sum a) -> Int #

basicUnsafeSlice :: Int -> Int -> MVector s (Sum a) -> MVector s (Sum a) #

basicOverlaps :: MVector s (Sum a) -> MVector s (Sum a) -> Bool #

basicUnsafeNew :: Int -> ST s (MVector s (Sum a)) #

basicInitialize :: MVector s (Sum a) -> ST s () #

basicUnsafeReplicate :: Int -> Sum a -> ST s (MVector s (Sum a)) #

basicUnsafeRead :: MVector s (Sum a) -> Int -> ST s (Sum a) #

basicUnsafeWrite :: MVector s (Sum a) -> Int -> Sum a -> ST s () #

basicClear :: MVector s (Sum a) -> ST s () #

basicSet :: MVector s (Sum a) -> Sum a -> ST s () #

basicUnsafeCopy :: MVector s (Sum a) -> MVector s (Sum a) -> ST s () #

basicUnsafeMove :: MVector s (Sum a) -> MVector s (Sum a) -> ST s () #

basicUnsafeGrow :: MVector s (Sum a) -> Int -> ST s (MVector s (Sum a)) #

Prim a => MVector MVector (UnboxViaPrim a) # |

Instance details

Defined in Data.Vector.Unboxed.Base

Methods

basicLength :: MVector s (UnboxViaPrim a) -> Int #

basicUnsafeSlice :: Int -> Int -> MVector s (UnboxViaPrim a) -> MVector s (UnboxViaPrim a) #

basicOverlaps :: MVector s (UnboxViaPrim a) -> MVector s (UnboxViaPrim a) -> Bool #

basicUnsafeNew :: Int -> ST s (MVector s (UnboxViaPrim a)) #

basicInitialize :: MVector s (UnboxViaPrim a) -> ST s () #

basicUnsafeReplicate :: Int -> UnboxViaPrim a -> ST s (MVector s (UnboxViaPrim a)) #

basicUnsafeRead :: MVector s (UnboxViaPrim a) -> Int -> ST s (UnboxViaPrim a) #

basicUnsafeWrite :: MVector s (UnboxViaPrim a) -> Int -> UnboxViaPrim a -> ST s () #

basicClear :: MVector s (UnboxViaPrim a) -> ST s () #

basicSet :: MVector s (UnboxViaPrim a) -> UnboxViaPrim a -> ST s () #

basicUnsafeCopy :: MVector s (UnboxViaPrim a) -> MVector s (UnboxViaPrim a) -> ST s () #

basicUnsafeMove :: MVector s (UnboxViaPrim a) -> MVector s (UnboxViaPrim a) -> ST s () #

basicUnsafeGrow :: MVector s (UnboxViaPrim a) -> Int -> ST s (MVector s (UnboxViaPrim a)) #

(Unbox a, Unbox b) => MVector MVector (Arg a b) # |

Instance details

Defined in Data.Vector.Unboxed.Base

Methods

basicLength :: MVector s (Arg a b) -> Int #

basicUnsafeSlice :: Int -> Int -> MVector s (Arg a b) -> MVector s (Arg a b) #

basicOverlaps :: MVector s (Arg a b) -> MVector s (Arg a b) -> Bool #

basicUnsafeNew :: Int -> ST s (MVector s (Arg a b)) #

basicInitialize :: MVector s (Arg a b) -> ST s () #

basicUnsafeReplicate :: Int -> Arg a b -> ST s (MVector s (Arg a b)) #

basicUnsafeRead :: MVector s (Arg a b) -> Int -> ST s (Arg a b) #

basicUnsafeWrite :: MVector s (Arg a b) -> Int -> Arg a b -> ST s () #

basicClear :: MVector s (Arg a b) -> ST s () #

basicSet :: MVector s (Arg a b) -> Arg a b -> ST s () #

basicUnsafeCopy :: MVector s (Arg a b) -> MVector s (Arg a b) -> ST s () #

basicUnsafeMove :: MVector s (Arg a b) -> MVector s (Arg a b) -> ST s () #

basicUnsafeGrow :: MVector s (Arg a b) -> Int -> ST s (MVector s (Arg a b)) #

(IsoUnbox a b, Unbox b) => MVector MVector (As a b) # |

Instance details

Defined in Data.Vector.Unboxed.Base

Methods

basicLength :: MVector s (As a b) -> Int #

basicUnsafeSlice :: Int -> Int -> MVector s (As a b) -> MVector s (As a b) #

basicOverlaps :: MVector s (As a b) -> MVector s (As a b) -> Bool #

basicUnsafeNew :: Int -> ST s (MVector s (As a b)) #

basicInitialize :: MVector s (As a b) -> ST s () #

basicUnsafeReplicate :: Int -> As a b -> ST s (MVector s (As a b)) #

basicUnsafeRead :: MVector s (As a b) -> Int -> ST s (As a b) #

basicUnsafeWrite :: MVector s (As a b) -> Int -> As a b -> ST s () #

basicClear :: MVector s (As a b) -> ST s () #

basicSet :: MVector s (As a b) -> As a b -> ST s () #

basicUnsafeCopy :: MVector s (As a b) -> MVector s (As a b) -> ST s () #

basicUnsafeMove :: MVector s (As a b) -> MVector s (As a b) -> ST s () #

basicUnsafeGrow :: MVector s (As a b) -> Int -> ST s (MVector s (As a b)) #

(Unbox a, Unbox b) => MVector MVector (a, b) # |

Instance details

Defined in Data.Vector.Unboxed.Base

Methods

basicLength :: MVector s (a, b) -> Int #

basicUnsafeSlice :: Int -> Int -> MVector s (a, b) -> MVector s (a, b) #

basicOverlaps :: MVector s (a, b) -> MVector s (a, b) -> Bool #

basicUnsafeNew :: Int -> ST s (MVector s (a, b)) #

basicInitialize :: MVector s (a, b) -> ST s () #

basicUnsafeReplicate :: Int -> (a, b) -> ST s (MVector s (a, b)) #

basicUnsafeRead :: MVector s (a, b) -> Int -> ST s (a, b) #

basicUnsafeWrite :: MVector s (a, b) -> Int -> (a, b) -> ST s () #

basicClear :: MVector s (a, b) -> ST s () #

basicSet :: MVector s (a, b) -> (a, b) -> ST s () #

basicUnsafeCopy :: MVector s (a, b) -> MVector s (a, b) -> ST s () #

basicUnsafeMove :: MVector s (a, b) -> MVector s (a, b) -> ST s () #

basicUnsafeGrow :: MVector s (a, b) -> Int -> ST s (MVector s (a, b)) #

Unbox a => MVector MVector (Const a b) # |

Instance details

Defined in Data.Vector.Unboxed.Base

Methods

basicLength :: MVector s (Const a b) -> Int #

basicUnsafeSlice :: Int -> Int -> MVector s (Const a b) -> MVector s (Const a b) #

basicOverlaps :: MVector s (Const a b) -> MVector s (Const a b) -> Bool #

basicUnsafeNew :: Int -> ST s (MVector s (Const a b)) #

basicInitialize :: MVector s (Const a b) -> ST s () #

basicUnsafeReplicate :: Int -> Const a b -> ST s (MVector s (Const a b)) #

basicUnsafeRead :: MVector s (Const a b) -> Int -> ST s (Const a b) #

basicUnsafeWrite :: MVector s (Const a b) -> Int -> Const a b -> ST s () #

basicClear :: MVector s (Const a b) -> ST s () #

basicSet :: MVector s (Const a b) -> Const a b -> ST s () #

basicUnsafeCopy :: MVector s (Const a b) -> MVector s (Const a b) -> ST s () #

basicUnsafeMove :: MVector s (Const a b) -> MVector s (Const a b) -> ST s () #

basicUnsafeGrow :: MVector s (Const a b) -> Int -> ST s (MVector s (Const a b)) #

Unbox (f a) => MVector MVector (Alt f a) # |

Instance details

Defined in Data.Vector.Unboxed.Base

Methods

basicLength :: MVector s (Alt f a) -> Int #

basicUnsafeSlice :: Int -> Int -> MVector s (Alt f a) -> MVector s (Alt f a) #

basicOverlaps :: MVector s (Alt f a) -> MVector s (Alt f a) -> Bool #

basicUnsafeNew :: Int -> ST s (MVector s (Alt f a)) #

basicInitialize :: MVector s (Alt f a) -> ST s () #

basicUnsafeReplicate :: Int -> Alt f a -> ST s (MVector s (Alt f a)) #

basicUnsafeRead :: MVector s (Alt f a) -> Int -> ST s (Alt f a) #

basicUnsafeWrite :: MVector s (Alt f a) -> Int -> Alt f a -> ST s () #

basicClear :: MVector s (Alt f a) -> ST s () #

basicSet :: MVector s (Alt f a) -> Alt f a -> ST s () #

basicUnsafeCopy :: MVector s (Alt f a) -> MVector s (Alt f a) -> ST s () #

basicUnsafeMove :: MVector s (Alt f a) -> MVector s (Alt f a) -> ST s () #

basicUnsafeGrow :: MVector s (Alt f a) -> Int -> ST s (MVector s (Alt f a)) #

(Unbox a, Unbox b, Unbox c) => MVector MVector (a, b, c) # |

Instance details

Defined in Data.Vector.Unboxed.Base

Methods

basicLength :: MVector s (a, b, c) -> Int #

basicUnsafeSlice :: Int -> Int -> MVector s (a, b, c) -> MVector s (a, b, c) #

basicOverlaps :: MVector s (a, b, c) -> MVector s (a, b, c) -> Bool #

basicUnsafeNew :: Int -> ST s (MVector s (a, b, c)) #

basicInitialize :: MVector s (a, b, c) -> ST s () #

basicUnsafeReplicate :: Int -> (a, b, c) -> ST s (MVector s (a, b, c)) #

basicUnsafeRead :: MVector s (a, b, c) -> Int -> ST s (a, b, c) #

basicUnsafeWrite :: MVector s (a, b, c) -> Int -> (a, b, c) -> ST s () #

basicClear :: MVector s (a, b, c) -> ST s () #

basicSet :: MVector s (a, b, c) -> (a, b, c) -> ST s () #

basicUnsafeCopy :: MVector s (a, b, c) -> MVector s (a, b, c) -> ST s () #

basicUnsafeMove :: MVector s (a, b, c) -> MVector s (a, b, c) -> ST s () #

basicUnsafeGrow :: MVector s (a, b, c) -> Int -> ST s (MVector s (a, b, c)) #

(Unbox a, Unbox b, Unbox c, Unbox d) => MVector MVector (a, b, c, d) # |

Instance details

Defined in Data.Vector.Unboxed.Base

Methods

basicLength :: MVector s (a, b, c, d) -> Int #

basicUnsafeSlice :: Int -> Int -> MVector s (a, b, c, d) -> MVector s (a, b, c, d) #

basicOverlaps :: MVector s (a, b, c, d) -> MVector s (a, b, c, d) -> Bool #

basicUnsafeNew :: Int -> ST s (MVector s (a, b, c, d)) #

basicInitialize :: MVector s (a, b, c, d) -> ST s () #

basicUnsafeReplicate :: Int -> (a, b, c, d) -> ST s (MVector s (a, b, c, d)) #

basicUnsafeRead :: MVector s (a, b, c, d) -> Int -> ST s (a, b, c, d) #

basicUnsafeWrite :: MVector s (a, b, c, d) -> Int -> (a, b, c, d) -> ST s () #

basicClear :: MVector s (a, b, c, d) -> ST s () #

basicSet :: MVector s (a, b, c, d) -> (a, b, c, d) -> ST s () #

basicUnsafeCopy :: MVector s (a, b, c, d) -> MVector s (a, b, c, d) -> ST s () #

basicUnsafeMove :: MVector s (a, b, c, d) -> MVector s (a, b, c, d) -> ST s () #

basicUnsafeGrow :: MVector s (a, b, c, d) -> Int -> ST s (MVector s (a, b, c, d)) #

Unbox (f (g a)) => MVector MVector (Compose f g a) # |

Instance details

Defined in Data.Vector.Unboxed.Base

Methods

basicLength :: MVector s (Compose f g a) -> Int #

basicUnsafeSlice :: Int -> Int -> MVector s (Compose f g a) -> MVector s (Compose f g a) #

basicOverlaps :: MVector s (Compose f g a) -> MVector s (Compose f g a) -> Bool #

basicUnsafeNew :: Int -> ST s (MVector s (Compose f g a)) #

basicInitialize :: MVector s (Compose f g a) -> ST s () #

basicUnsafeReplicate :: Int -> Compose f g a -> ST s (MVector s (Compose f g a)) #

basicUnsafeRead :: MVector s (Compose f g a) -> Int -> ST s (Compose f g a) #

basicUnsafeWrite :: MVector s (Compose f g a) -> Int -> Compose f g a -> ST s () #

basicClear :: MVector s (Compose f g a) -> ST s () #

basicSet :: MVector s (Compose f g a) -> Compose f g a -> ST s () #

basicUnsafeCopy :: MVector s (Compose f g a) -> MVector s (Compose f g a) -> ST s () #

basicUnsafeMove :: MVector s (Compose f g a) -> MVector s (Compose f g a) -> ST s () #

basicUnsafeGrow :: MVector s (Compose f g a) -> Int -> ST s (MVector s (Compose f g a)) #

(Unbox a, Unbox b, Unbox c, Unbox d, Unbox e) => MVector MVector (a, b, c, d, e) # |

Instance details

Defined in Data.Vector.Unboxed.Base

Methods

basicLength :: MVector s (a, b, c, d, e) -> Int #

basicUnsafeSlice :: Int -> Int -> MVector s (a, b, c, d, e) -> MVector s (a, b, c, d, e) #

basicOverlaps :: MVector s (a, b, c, d, e) -> MVector s (a, b, c, d, e) -> Bool #

basicUnsafeNew :: Int -> ST s (MVector s (a, b, c, d, e)) #

basicInitialize :: MVector s (a, b, c, d, e) -> ST s () #

basicUnsafeReplicate :: Int -> (a, b, c, d, e) -> ST s (MVector s (a, b, c, d, e)) #

basicUnsafeRead :: MVector s (a, b, c, d, e) -> Int -> ST s (a, b, c, d, e) #

basicUnsafeWrite :: MVector s (a, b, c, d, e) -> Int -> (a, b, c, d, e) -> ST s () #

basicClear :: MVector s (a, b, c, d, e) -> ST s () #

basicSet :: MVector s (a, b, c, d, e) -> (a, b, c, d, e) -> ST s () #

basicUnsafeCopy :: MVector s (a, b, c, d, e) -> MVector s (a, b, c, d, e) -> ST s () #

basicUnsafeMove :: MVector s (a, b, c, d, e) -> MVector s (a, b, c, d, e) -> ST s () #

basicUnsafeGrow :: MVector s (a, b, c, d, e) -> Int -> ST s (MVector s (a, b, c, d, e)) #

(Unbox a, Unbox b, Unbox c, Unbox d, Unbox e, Unbox f) => MVector MVector (a, b, c, d, e, f) # |

Instance details

Defined in Data.Vector.Unboxed.Base

Methods

basicLength :: MVector s (a, b, c, d, e, f) -> Int #

basicUnsafeSlice :: Int -> Int -> MVector s (a, b, c, d, e, f) -> MVector s (a, b, c, d, e, f) #

basicOverlaps :: MVector s (a, b, c, d, e, f) -> MVector s (a, b, c, d, e, f) -> Bool #

basicUnsafeNew :: Int -> ST s (MVector s (a, b, c, d, e, f)) #

basicInitialize :: MVector s (a, b, c, d, e, f) -> ST s () #

basicUnsafeReplicate :: Int -> (a, b, c, d, e, f) -> ST s (MVector s (a, b, c, d, e, f)) #

basicUnsafeRead :: MVector s (a, b, c, d, e, f) -> Int -> ST s (a, b, c, d, e, f) #

basicUnsafeWrite :: MVector s (a, b, c, d, e, f) -> Int -> (a, b, c, d, e, f) -> ST s () #

basicClear :: MVector s (a, b, c, d, e, f) -> ST s () #

basicSet :: MVector s (a, b, c, d, e, f) -> (a, b, c, d, e, f) -> ST s () #

basicUnsafeCopy :: MVector s (a, b, c, d, e, f) -> MVector s (a, b, c, d, e, f) -> ST s () #

basicUnsafeMove :: MVector s (a, b, c, d, e, f) -> MVector s (a, b, c, d, e, f) -> ST s () #

basicUnsafeGrow :: MVector s (a, b, c, d, e, f) -> Int -> ST s (MVector s (a, b, c, d, e, f)) #